<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      procart Enterprise 3.8                                       ***
  ***      File:  posnet.php                                               ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.procart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


/*
 * Posnet (setmpos.ykb.com) transaction handler by www.procart.com
 */

	$pass_data = array();
	foreach ($payment_parameters as $parameter_name => $parameter_value) {
		if(isset($pass_parameters[$parameter_name]) && $pass_parameters[$parameter_name] == 1) {
			$pass_data[$parameter_name] = $parameter_value;
		}
	}
	$xml = buildXML($pass_data);
	$user_agent = "Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)";

	$ch = curl_init();
	curl_setopt($ch, CURLOPT_POST,1);
	curl_setopt($ch, CURLOPT_POSTFIELDS,$xml);
	curl_setopt($ch, CURLOPT_URL,$advanced_url);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,  FALSE);
	curl_setopt($ch, CURLOPT_USERAGENT, $user_agent);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
	curl_setopt($ch, CURLOPT_TIMEOUT, 30);

	$payment_response=curl_exec ($ch);
	if (curl_errno($ch)) {
		$error_message = curl_errno($ch)." - ".curl_error($ch);
	}
	curl_close ($ch);

	$payment_response = trim($payment_response);
	if ($payment_response) {
		$response_parameters = array();
		preg_match_all ("/<([^>]*?)>([^<]*?)\<\/[^>]*>/", $payment_response, $matches, PREG_SET_ORDER);
		for($i = 0; $i < sizeof($matches); $i++) {
			$response_parameters[$matches[$i][1]] = ($matches[$i][2]);
		}

		if (!isset($response_parameters["approved"])) {
			$error_message = "Can't obtain authorization parameter.";
		} else if ($response_parameters["approved"] != 1) {
			if (isset($response_parameters["respCode"]) && strlen($response_parameters["respCode"])) {
				$error_message = $response_parameters["respCode"];
				if (isset($response_parameters["respText"])) {
					$error_message .= " - ".$response_parameters["respText"];
				}
			} else {
				$error_message = "Your transaction has been declined.";
			}
		} else {
			$transaction_id = $response_parameters["authCode"];
		}

	} else {
		$error_message = "Empty response from gateway. Please check your settings.";
	}

	function buildXML($pdata)
	{
		$xml  = "xmldata=";
		$xml .=		"<posnetRequest>";
		if (isset($pdata["mid"])) {
		$xml .=			"<mid>".$pdata["mid"]."</mid>";
		}
		if (isset($pdata["tid"])) {
		$xml .=			"<tid>".$pdata["tid"]."</tid>";
		}
		if (isset($pdata["username"])) {
		$xml .=			"<username>".$pdata["username"]."</username>";
		}
		if (isset($pdata["password"])) {
		$xml .=			"<password>".$pdata["password"]."</password>";
		}
		$xml .=			"<sale>";
		if (isset($pdata["ccno"])) {
		$xml .=				"<ccno>".$pdata["ccno"]."</ccno>";
		}
		if (isset($pdata["cardexpmonth"]) && isset($pdata["cardexpyear"])) {
		$xml .=				"<expDate>".$pdata["cardexpyear"].$pdata["cardexpmonth"]."</expDate>";
		}
		if (isset($pdata["cvc"])) {
		$xml .=				"<cvc>".$pdata["cvc"]."</cvc>";
		}
		if (isset($pdata["amount"])) {
		$xml .=				"<amount>".intval($pdata["amount"]*100)."</amount>";
		}
		if (isset($pdata["currencycode"])) {
		$xml .=				"<currencyCode>".$pdata["currencycode"]."</currencyCode>";
		}
		if (isset($pdata["orderid"])) {
			$orderid = strval($pdata["orderid"]);
			for ($i = strlen($orderid); $i < 24; $i++) {
				$orderid = '0'.$orderid;
			}
		$xml .=				"<orderID>".$orderid."</orderID>";
		}
		if (isset($pdata["installment"])) {
		$xml .=				"<installment>".$pdata["installment"]."</installment>";
		}
		if (isset($pdata["extrapoint"])) {
		$xml .=				"<extraPoint>".$pdata["extrapoint"]."</extraPoint>";
		}
		if (isset($pdata["multiplepoint"])) {
		$xml .=				"<multiplePoint>".$pdata["multiplepoint"]."</multiplePoint>";
		}
		$xml .=			"</sale>";
		$xml .=		"</posnetRequest>";
		return $xml;
	}

?>